G. Underfail
You have recently fallen through a hole and, after several hours of unconsciousness, have realized you are in an underground city. On one of your regular, daily walks through the unknown, you have encountered two unusually looking skeletons called Sanz and P’pairus, who decided to accompany you and give you some puzzles for seemingly unknown reasons.
One day, Sanz has created a crossword for you. Not any kind of crossword, but a 1D crossword! You are given m words and a string of length n. You are also given an array p, which designates how much each word is worth — the i-th word is worth pi points. Whenever you find one of the m words in the string, you are given the corresponding number of points. Each position in the crossword can be used at most x times. A certain word can be counted at different places, but you cannot count the same appearance of a word multiple times. If a word is a substring of another word, you can count them both (presuming you haven’t used the positions more than x times).
In order to solve the puzzle, you need to tell Sanz what’s the maximum achievable number of points in the crossword. There is no need to cover all postions, just get the maximal score! Crossword and words contain only lowercase English letters.
Input
The first line of the input contains a single integer n (1 ≤ n ≤ 500) — the length of the crossword. The second line contains the crossword string. The third line contains a single integer m (1 ≤ m ≤ 100) — the number of given words, and next m lines contain description of words: each line will have a string representing a non-empty word (its length doesn't exceed the length of the crossword) and integer pi (0 ≤ pi ≤ 100). Last line of the input will contain x (1 ≤ x ≤ 100) — maximum number of times a position in crossword can be used.
Output
Output single integer — maximum number of points you can get.
Example
6
abacba
2
aba 6
ba 3
3
12
Note
For example, with the string "abacba", words "aba" (6 points) and "ba" (3 points), and x = 3, you can get at most 12 points - the word "aba" appears once ("abacba"), while "ba" appears two times ("abacba"). Note that for x = 1, you could get at most 9 points, since you wouldn’t be able to count both "aba" and the first appearance of "ba".
Solution
题目大意:给定一个长度为N的模板串,以及M个短串,每个短串有一个价值c,用一个短串完全匹配模板串的区间,可以得到短串的价值。每个短串可以匹配任意次,模板串的每个位置,只能匹配K次。求最大价值。
这道题还是比较容易想到的
首先把所有短串去和大串匹配,得到每个小串的完全匹配的区间。 然后套用费用流经典建图。
这个过程可以暴力,Hash,AC自动机,KMP...
然后对于这个区间$[l,r]$,我们连边$<l,r+1>,cap=1,cost=c$ ,这里连边$<l,r+1>$是控制区间左闭右开,否则会出现负环。
然后连$<S,1>,cap=K,cost=0$以及$<N,T>,cap=K,cost=0$ ,前一个位置向后一个位置连边$<i,i+1>,cap=K,cost=0$
然后跑$S->T$的最大费用最大流就是答案。
Code
#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
#include<queue>
using namespace std;
inline int read()
{
int x=,f=; char ch=getchar();
while (ch<'' || ch>'') {if (ch=='-') f=-; ch=getchar();}
while (ch>='' && ch<='') {x=x*+ch-''; ch=getchar();}
return x*f;
}
#define MAXN 510
int N,M,K,c[];
char s[MAXN],ss[][];
namespace Hash
{
#define base 131
#define ULL unsigned long long
ULL hash[MAXN],bin[MAXN];
void Hashtable()
{
bin[]=; for (int i=; i<=N; i++) bin[i]=bin[i-]*base;
for (int i=; i<=N; i++) hash[i]=hash[i-]*base+s[i];
}
ULL GetHash(int l,int r) {return hash[r]-hash[l-]*bin[r-l+];}
ULL Hashit(char st[])
{
ULL re=; int len=strlen(st+);
for (int i=; i<=len; i++) re=re*base+st[i];
return re;
}
}
using namespace Hash;
namespace CostFlow
{
#define INF 0x7fffffff
#define MAXM 100010
struct EdgeNode{int next,to,cap,cost,from;}edge[MAXM<<];
int head[MAXN],cnt=;
inline void AddEdge(int u,int v,int w,int c) {cnt++; edge[cnt].to=v; edge[cnt].next=head[u]; head[u]=cnt; edge[cnt].cap=w; edge[cnt].cost=c; edge[cnt].from=u;}
inline void InsertEdge(int u,int v,int w,int c) {AddEdge(u,v,w,c); AddEdge(v,u,,-c);}
int S,T,Cost,dis[MAXN],visit[MAXN],mark[MAXN];
queue<int>q;
inline bool SPFA()
{
for (int i=S; i<=T; i++) dis[i]=-INF;
q.push(S); visit[S]=; dis[S]=;
while (!q.empty())
{
int now=q.front(); q.pop(); visit[now]=;
for (int i=head[now]; i; i=edge[i].next)
if (edge[i].cap && dis[edge[i].to]<dis[now]+edge[i].cost)
{
dis[edge[i].to]=dis[now]+edge[i].cost;
if (!visit[edge[i].to]) q.push(edge[i].to),visit[edge[i].to]=;
}
}
return dis[T]!=-INF;
}
inline int dfs(int now,int low)
{
mark[now]=;
if (now==T) return low;
int w,used=;
for (int i=head[now]; i; i=edge[i].next)
if (!mark[edge[i].to] && edge[i].cap && dis[edge[i].to]==dis[now]+edge[i].cost)
{
w=dfs(edge[i].to,min(low-used,edge[i].cap));
edge[i].cap-=w; edge[i^].cap+=w; Cost+=w*edge[i].cost; used+=w;
if (used==low) return low;
}
return used;
}
inline int zkw()
{
int re=;
while (SPFA())
{
mark[T]=;
while (mark[T])
memset(mark,,sizeof(mark)),re+=dfs(S,INF);
}
return re;
}
inline void BuildGraph()
{
S=,T=N+;
Hash::Hashtable();
InsertEdge(S,,K,); InsertEdge(N,T,K,);
for (int i=; i<=N-; i++) InsertEdge(i,i+,K,);
for (int i=; i<=M; i++)
{
ULL _hash=Hash::Hashit(ss[i]); int l=strlen(ss[i]+);
for (int j=; j+l-<=N; j++)
if (Hash::GetHash(j,j+l-)==_hash) InsertEdge(j,j+l,,c[i]);
}
// for (int i=2; i<=cnt; i+=2) printf("%d %d %d %d\n",edge[i].from,edge[i].to,edge[i].cap,edge[i].cost);
}
}
int main()
{
N=read(); scanf("%s",s+);
M=read();
for (int i=; i<=M; i++) scanf("%s",ss[i]+),c[i]=read();
K=read();
CostFlow::BuildGraph();
CostFlow::zkw();
printf("%d\n",CostFlow::Cost);
return ;
}
Codeforces上的数据真是太小了...这个题暴力都能跑的那么快...
【Codeforces717G】Underfail Hash + 最大费用最大流的更多相关文章
-
Codeforces 717G Underfail(最小费用最大流 + AC自动机)
题目 Source http://codeforces.com/problemset/problem/717/G Description You have recently fallen throug ...
-
[CODEVS1917] 深海机器人问题(最小费用最大流)
传送门 [问题分析] 最大费用最大流问题. [建模方法] 把网格中每个位置抽象成网络中一个节点,建立附加源S汇T. 1.对于每个顶点i,j为i东边或南边相邻的一个节点,连接节点i与节点j一条容量为1, ...
-
[板子]最小费用最大流(Dijkstra增广)
最小费用最大流板子,没有压行.利用重标号让边权非负,用Dijkstra进行增广,在理论和实际上都比SPFA增广快得多.教程略去.转载请随意. #include <cstdio> #incl ...
-
bzoj1927最小费用最大流
其实本来打算做最小费用最大流的题目前先来点模板题的,,,结果看到这道题二话不说(之前打太多了)敲了一个dinic,快写完了发现不对 我当时就这表情→ =_=你TM逗我 刚要删突然感觉dinic的模 ...
-
ACM/ICPC 之 卡卡的矩阵旅行-最小费用最大流(可做模板)(POJ3422)
将每个点拆分成原点A与伪点B,A->B有两条单向路(邻接表实现时需要建立一条反向的空边,并保证环路费用和为0),一条残留容量为1,费用为本身的负值(便于计算最短路),另一条残留容量+∞,费用为0 ...
-
HDU5900 QSC and Master(区间DP + 最小费用最大流)
题目 Source http://acm.hdu.edu.cn/showproblem.php?pid=5900 Description Every school has some legends, ...
-
P3381 【模板】最小费用最大流
P3381 [模板]最小费用最大流 题目描述 如题,给出一个网络图,以及其源点和汇点,每条边已知其最大流量和单位流量费用,求出其网络最大流和在最大流情况下的最小费用. 输入输出格式 输入格式: 第一行 ...
-
最小/大费用最大流模板(codevs1914)
void addedge(int fr,int to,int cap,int cos){ sid[cnt].fr=fr;sid[cnt].des=to;sid[cnt].cap=cap;sid[cnt ...
-
【BZOJ-4514】数字配对 最大费用最大流 + 质因数分解 + 二分图 + 贪心 + 线性筛
4514: [Sdoi2016]数字配对 Time Limit: 10 Sec Memory Limit: 128 MBSubmit: 726 Solved: 309[Submit][Status ...
随机推荐
-
Code Complete 笔记—— 第一章
软件的构建的主要流程: 定义问题 ( Problem Definition) 需求分析 (Requirements Development) 规划构建 (construction planning) ...
-
stunnel+CCProxy,搭建加密代理
总所周知,不可抗拒的特别有用心的原因,我们无法访问youtube,picasa,Twitter……国外优秀网站,很多人采用了代理服务器的方法访问. 如果您有一台放在海外的服务器,这个就好办了.下载一个 ...
-
JQuery------prevAll(),nextAll(),attr()方法的使用
$(this).nextAll(".Rec").find("input").attr("checked", false); $(this). ...
-
Resharp最新破解方法
ReSharper是一个JetBrains公司出品的著名的代码生成工具,其能帮助Microsoft Visual Studio成为一个更佳的IDE.它包括一系列丰富的能大大增加C#和Visual Ba ...
-
Swift游戏实战-跑酷熊猫 06 创建平台类以及平台工厂类
这节内容我们一起学习下随机长度的踩踏平台的原理是怎么样的. 要点: 平台类 我们的平台类继承于SKNode,这样就能被添加进其它节点进而显示在场景中. 它有一个方法来创建平台,这个方法接收一个包含SK ...
-
探索版 webstorm快捷方式
ctrl + alt + s 打开配置面板 Settings 国内的资料比较少,大概很多人已经放弃了原生快捷方式,不过我打算通关原生快捷方式. 在配置面板中 IDE S ...
-
Node Express 初探
一如既往,先上一张图 Express 基于 Node.js 平台,快速.开放.极简的 web 开发框架. 关于Express更多相关知识请链接至官网http://www.expressjs.com.c ...
-
sql server 查询所有表结构
SELECT CASE WHEN col.colorder = 1 THEN obj.name ELSE '' END AS 表名, Coalesce(epTwo.value, '') AS docu ...
-
Spring PropertyEditor Spring conversion框架分析
PropertyEditor https://blog.csdn.net/pentiumchen/article/details/44026575 conversion https://blog.cs ...
-
“64位调试操作花费的时间比预期要长";,无法运行调试解决办法
以管理员身份在命令提示符那里打入如下命令: netsh winsock reset catalognetsh int ip reset reset.log hit 或者是 打开Microsoft Vi ...